"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = compileClassPropertyMatcher;

var _Placeholder = _interopRequireDefault(require("./Placeholder"));

function compileClassPropertyMatcher(path, compileOptions) {
  var pattern = path.value;
  var n = compileOptions.backend.t.namedTypes;

  if (n.Identifier.check(pattern.key)) {
    if (!pattern.computed && !pattern["static"] && pattern.variance == null && pattern.value == null) {
      var placeholderMatcher = (0, _Placeholder["default"])(path, pattern.key.name, compileOptions, {
        getCondition: function getCondition() {
          return function (path) {
            var _path$parent;

            return n.ClassBody.check((_path$parent = path.parent) === null || _path$parent === void 0 ? void 0 : _path$parent.value);
          };
        }
      });
      if (placeholderMatcher) return placeholderMatcher;
    }
  }
}