"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = compileExportSpecifierMatcher;

var _Placeholder = _interopRequireDefault(require("./Placeholder"));

function compileExportSpecifierMatcher(path, compileOptions) {
  var n = compileOptions.backend.t.namedTypes;
  var pattern = path.value;
  var _ref = pattern,
      exportKind = _ref.exportKind;
  var exported = pattern.exported,
      local = pattern.local;

  if (n.Identifier.check(exported) && (!local || local.name === exported.name)) {
    if (exportKind == null || exportKind === 'value') {
      var placeholderMatcher = (0, _Placeholder["default"])(path, exported.name, compileOptions, {
        nodeType: ['ExportSpecifier', 'ExportDefaultSpecifier', 'ExportNamespaceSpecifier']
      });
      if (placeholderMatcher) return placeholderMatcher;
    }
  }
}