'use strict'

var _interopRequireDefault = require('@babel/runtime/helpers/interopRequireDefault')

Object.defineProperty(exports, '__esModule', {
  value: true,
})
exports['default'] = compileGenericNodeReplacement

var _defineProperty2 = _interopRequireDefault(
  require('@babel/runtime/helpers/defineProperty')
)

var _slicedToArray2 = _interopRequireDefault(
  require('@babel/runtime/helpers/slicedToArray')
)

var _index = _interopRequireDefault(require('./index'))

var _indentDebug = _interopRequireDefault(
  require('../compileMatcher/indentDebug')
)

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object)

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object)
    enumerableOnly &&
      (symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable
      })),
      keys.push.apply(keys, symbols)
  }

  return keys
}

function _objectSpread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {}
    i % 2
      ? ownKeys(Object(source), !0).forEach(function (key) {
          ;(0, _defineProperty2['default'])(target, key, source[key])
        })
      : Object.getOwnPropertyDescriptors
      ? Object.defineProperties(
          target,
          Object.getOwnPropertyDescriptors(source)
        )
      : ownKeys(Object(source)).forEach(function (key) {
          Object.defineProperty(
            target,
            key,
            Object.getOwnPropertyDescriptor(source, key)
          )
        })
  }

  return target
}

function _createForOfIteratorHelper(o, allowArrayLike) {
  var it =
    (typeof Symbol !== 'undefined' && o[Symbol.iterator]) || o['@@iterator']

  if (!it) {
    if (
      Array.isArray(o) ||
      (it = _unsupportedIterableToArray(o)) ||
      (allowArrayLike && o && typeof o.length === 'number')
    ) {
      if (it) o = it
      var i = 0

      var F = function F() {}

      return {
        s: F,
        n: function n() {
          if (i >= o.length)
            return {
              done: true,
            }
          return {
            done: false,
            value: o[i++],
          }
        },
        e: function e(_e) {
          throw _e
        },
        f: F,
      }
    }

    throw new TypeError(
      'Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.'
    )
  }

  var normalCompletion = true,
    didErr = false,
    err
  return {
    s: function s() {
      it = it.call(o)
    },
    n: function n() {
      var step = it.next()
      normalCompletion = step.done
      return step
    },
    e: function e(_e2) {
      didErr = true
      err = _e2
    },
    f: function f() {
      try {
        if (!normalCompletion && it['return'] != null) it['return']()
      } finally {
        if (didErr) throw err
      }
    },
  }
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return
  if (typeof o === 'string') return _arrayLikeToArray(o, minLen)
  var n = Object.prototype.toString.call(o).slice(8, -1)
  if (n === 'Object' && o.constructor) n = o.constructor.name
  if (n === 'Map' || n === 'Set') return Array.from(o)
  if (n === 'Arguments' || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))
    return _arrayLikeToArray(o, minLen)
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length

  for (var i = 0, arr2 = new Array(len); i < len; i++) {
    arr2[i] = arr[i]
  }

  return arr2
}

function compileGenericNodeReplacement(path, compileOptions) {
  var pattern = path.value
  var t = compileOptions.backend.t
  var debug = compileOptions.debug
  var propertyValues = []
  var childReplacements = []

  var _iterator = _createForOfIteratorHelper(t.getFieldNames(pattern)),
    _step

  try {
    for (_iterator.s(); !(_step = _iterator.n()).done; ) {
      var key = _step.value
      var value = t.getFieldValue(pattern, key)
      var fieldPath = path.get(key)

      if (
        Array.isArray(fieldPath.value) ||
        fieldPath.node === fieldPath.value
      ) {
        childReplacements.push([
          key,
          (0, _index['default'])(
            fieldPath,
            _objectSpread(
              _objectSpread({}, compileOptions),
              {},
              {
                debug: (0, _indentDebug['default'])(debug, 2),
              }
            )
          ),
        ])
      } else {
        propertyValues.push([key, value])
      }
    }
  } catch (err) {
    _iterator.e(err)
  } finally {
    _iterator.f()
  }

  return {
    generate: function generate(match) {
      var result = {
        type: pattern.type,
      }

      var _iterator2 = _createForOfIteratorHelper(childReplacements),
        _step2

      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done; ) {
          var _step2$value = (0, _slicedToArray2['default'])(_step2.value, 2),
            key = _step2$value[0],
            replacement = _step2$value[1]

          var value = replacement.generate(match)
          if (value !== undefined) result[key] = value
        }
      } catch (err) {
        _iterator2.e(err)
      } finally {
        _iterator2.f()
      }

      var _iterator3 = _createForOfIteratorHelper(propertyValues),
        _step3

      try {
        for (_iterator3.s(); !(_step3 = _iterator3.n()).done; ) {
          var _step3$value = (0, _slicedToArray2['default'])(_step3.value, 2),
            _key = _step3$value[0],
            _value = _step3$value[1]

          if (_value !== undefined) result[_key] = _value
        }
      } catch (err) {
        _iterator3.e(err)
      } finally {
        _iterator3.f()
      }

      return result
    },
  }
}