'use strict'

var _interopRequireDefault = require('@babel/runtime/helpers/interopRequireDefault')

var _typeof = require('@babel/runtime/helpers/typeof')

Object.defineProperty(exports, '__esModule', {
  value: true,
})
exports['default'] = convertImportSpecifierReplacement

var _slicedToArray2 = _interopRequireDefault(
  require('@babel/runtime/helpers/slicedToArray')
)

var t = _interopRequireWildcard(require('@babel/types'))

var _convertToIdentifierPair = _interopRequireDefault(
  require('./convertToIdentifierPair')
)

var _Identifier = _interopRequireDefault(require('./Identifier'))

function _getRequireWildcardCache(nodeInterop) {
  if (typeof WeakMap !== 'function') return null
  var cacheBabelInterop = new WeakMap()
  var cacheNodeInterop = new WeakMap()
  return (_getRequireWildcardCache = function _getRequireWildcardCache(
    nodeInterop
  ) {
    return nodeInterop ? cacheNodeInterop : cacheBabelInterop
  })(nodeInterop)
}

function _interopRequireWildcard(obj, nodeInterop) {
  if (!nodeInterop && obj && obj.__esModule) {
    return obj
  }

  if (
    obj === null ||
    (_typeof(obj) !== 'object' && typeof obj !== 'function')
  ) {
    return {
      default: obj,
    }
  }

  var cache = _getRequireWildcardCache(nodeInterop)

  if (cache && cache.has(obj)) {
    return cache.get(obj)
  }

  var newObj = {}
  var hasPropertyDescriptor =
    Object.defineProperty && Object.getOwnPropertyDescriptor

  for (var key in obj) {
    if (key !== 'default' && Object.prototype.hasOwnProperty.call(obj, key)) {
      var desc = hasPropertyDescriptor
        ? Object.getOwnPropertyDescriptor(obj, key)
        : null

      if (desc && (desc.get || desc.set)) {
        Object.defineProperty(newObj, key, desc)
      } else {
        newObj[key] = obj[key]
      }
    }
  }

  newObj['default'] = obj

  if (cache) {
    cache.set(obj, newObj)
  }

  return newObj
}

function _createForOfIteratorHelper(o, allowArrayLike) {
  var it =
    (typeof Symbol !== 'undefined' && o[Symbol.iterator]) || o['@@iterator']

  if (!it) {
    if (
      Array.isArray(o) ||
      (it = _unsupportedIterableToArray(o)) ||
      (allowArrayLike && o && typeof o.length === 'number')
    ) {
      if (it) o = it
      var i = 0

      var F = function F() {}

      return {
        s: F,
        n: function n() {
          if (i >= o.length)
            return {
              done: true,
            }
          return {
            done: false,
            value: o[i++],
          }
        },
        e: function e(_e) {
          throw _e
        },
        f: F,
      }
    }

    throw new TypeError(
      'Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.'
    )
  }

  var normalCompletion = true,
    didErr = false,
    err
  return {
    s: function s() {
      it = it.call(o)
    },
    n: function n() {
      var step = it.next()
      normalCompletion = step.done
      return step
    },
    e: function e(_e2) {
      didErr = true
      err = _e2
    },
    f: function f() {
      try {
        if (!normalCompletion && it['return'] != null) it['return']()
      } finally {
        if (didErr) throw err
      }
    },
  }
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return
  if (typeof o === 'string') return _arrayLikeToArray(o, minLen)
  var n = Object.prototype.toString.call(o).slice(8, -1)
  if (n === 'Object' && o.constructor) n = o.constructor.name
  if (n === 'Map' || n === 'Set') return Array.from(o)
  if (n === 'Arguments' || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))
    return _arrayLikeToArray(o, minLen)
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length

  for (var i = 0, arr2 = new Array(len); i < len; i++) {
    arr2[i] = arr[i]
  }

  return arr2
}

function convertImportSpecifierReplacement() {
  var convert = function convert(node) {
    switch (node.type) {
      case 'ImportDefaultSpecifier':
      case 'ImportNamespaceSpecifier':
      case 'ImportSpecifier':
        return node

      case 'ObjectExpression':
      case 'ObjectPattern':
      case 'ObjectTypeAnnotation':
      case 'TSTypeLiteral': {
        var result = []

        var _iterator = _createForOfIteratorHelper(
            node.type === 'TSTypeLiteral' ? node.members : node.properties
          ),
          _step

        try {
          for (_iterator.s(); !(_step = _iterator.n()).done; ) {
            var prop = _step.value

            var _keyValue = (0, _convertToIdentifierPair['default'])(prop)

            if (_keyValue) {
              var _keyValue2 = (0, _slicedToArray2['default'])(_keyValue, 2),
                key = _keyValue2[0],
                value = _keyValue2[1]

              result.push(
                key.name === 'default'
                  ? t.importDefaultSpecifier(value)
                  : t.importSpecifier(value, key)
              )
            }
          }
        } catch (err) {
          _iterator.e(err)
        } finally {
          _iterator.f()
        }
        return result
      }
    }

    var identifier = (0, _Identifier['default'])(node)

    if (identifier) {
      return t.importDefaultSpecifier(identifier)
    }

    var keyValue = (0, _convertToIdentifierPair['default'])(node)

    if (keyValue) {
      var _keyValue3 = (0, _slicedToArray2['default'])(keyValue, 2),
        _key = _keyValue3[0],
        _value = _keyValue3[1]

      return _key.name === 'default'
        ? t.importDefaultSpecifier(_value)
        : t.importSpecifier(_value, _key)
    }

    return node
  }

  return convert
}